#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Apr 28 10:28:53 2017

@author: jonleonhardsen
"""

import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import math

def resistanceData():
    global datapd
    global data
    global x
    global bulbConfigs
    xl = pd.ExcelFile("/.../.../.../.../.../.../.../Bulb_data.xlsx")
    xl.sheet_names
    datapd = xl.parse("full_agility")
    data = datapd.as_matrix()
    bulbConfigs = int(data[-1][9])
    i = 1
    while i <= len(data)-1: 
        if  data[i][9] == data[i-1][9]:
            i +=1 
        else: 
            break
    speedRecords = i
    minSpeed = data[0][0]
    maxSpeed = data[speedRecords-1][0]
    speedIncrements = (round((maxSpeed-minSpeed)/(speedRecords-1),1))
    
    
    rows = int((maxSpeed-minSpeed)*10+1)
    columns = int(1+2*bulbConfigs)
    x = np.zeros((rows,columns))
    speeds = np.linspace(minSpeed,maxSpeed,rows)
    for i in range(0,rows):
        x[i][0] = speeds[i]

    #Allocate total resistance
    increments = int(speedIncrements*10)
    columnStep = int(bulbConfigs-1)
    for i in range(0,columnStep+1):
        for j in range(0,speedRecords):
            x[j*increments][2*i+1] = round(data[(speedRecords)*i+j][8],2)

    #Allocate waveresistance
    for i in range(0,columnStep+1):
        for j in range(0,speedRecords):
            x[j*increments][2*(i+1)] = round(data[(speedRecords)*i+j][7],2)

    for i in range(0,len(x)):
        for j in range(1,len(x[0])):
            if x[i][j] == 0:
                if math.isnan(x[math.ceil(max(i,1)/increments)*increments][j]) == True:
                    x[i][j] = round(x[math.floor(i/increments)*increments][j] + (x[math.ceil((increments+max(i,1))/increments)*increments][j]-x[math.floor(i/increments)*increments][j])*(x[i][0]-x[math.floor(i/increments)*increments][0])/(x[math.ceil((increments+max(i,1))/increments)*increments][0]-x[math.floor(i/increments)*increments][0]),2)
                    x[math.ceil(max(i,1)/increments)*increments][j] = round(x[math.floor(i/increments)*increments][j] + (x[math.ceil((increments+max(i,1))/increments)*increments][j]-x[math.floor(i/increments)*increments][j])*(x[math.ceil(max(i,1)/increments)*increments][0]-x[math.floor(i/increments)*increments][0])/(x[math.ceil((increments+max(i,1))/increments)*increments][0]-x[math.floor(i/increments)*increments][0]),2)
                    
                else:
                    x[i][j] = round(x[math.floor(i/increments)*increments][j] + (x[math.ceil(max(i,1)/increments)*increments][j]-x[math.floor(i/increments)*increments][j])*(x[i][0]-x[math.floor(i/increments)*increments][0])/(x[math.ceil(max(i,1)/increments)*increments][0]-x[math.floor(i/increments)*increments][0]),2)
    
   
    plt.figure()
    for i in range(1,x.shape[1]):
        plt.plot(speeds, x[:,i])
   
    plt.xlabel('Speed [knots]')
    plt.ylabel('Resistance [Newton]')
    plt.show()
    

            
if __name__ == "__main__":       
    resistanceData()
        

