#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Feb 17 10:52:25 2017

@author: jonleonhardsen
"""

import PlotVessels as PV
import OU
import SpeedStatsBigShips as BS
import SpeedStatsPanamax as P
import Generate_Sailingspeeds as GS
import Fuel_Aggregated as FA

Segment = '/.../.../.../.../.../AIS/ContainerFleet.db'
Vessel = '/.../.../.../.../.../AIS/xyz.db'

#All methods are run from this script, 1 = run
SegmentAnalysis = 1 #1 = analyze segment, 0 = analyze vessel
GlobalMap = 0
LocalMap = 0
DraughtInterpolate = 0
TradeDirectionsSuez = 0
TradeDirectionPacific = 0
FreightRateImpact = 0
MonthlyAverage = 0
GeoDistribution = 0
SpeedDev = 0
SpeedHistogram = 0
SpeedForAnalysis = 0
GeoAnalysis = 0
CumulatedSpeed = 0
DraughtAnalysis = 0
OrnsteinUhlenbeckGenerator = 0

BigShips = 0
Panamax = 0
MuSim = 0
FuelCalc = 0
FuelAgg = 0

Pacific = [-120,63,12,28]
Atlanter = [0,53,-80,33]
MexAu = [180,7.75,-180,-26.10]
Global = [180,90,-180,-90]
asEur = [120, 50, -15, 0]

Loc = 4

if Loc == 1:
    Pos = Pacific
elif Loc == 2:
    Pos = Atlanter
elif Loc == 3:
    Pos = MexAu
elif Loc == 4:
    Pos = Global
elif Loc == 5:
    Pos = asEur
    
#PV calls PlotVessels.py, which essentially does all data extracting, initial analyses,
#and visualizations of AIS data.  
if SegmentAnalysis == 1:
    PV.ExtractData(Segment,Pos[0],Pos[1],Pos[2],Pos[3])
else:
    PV.ExtractData(Vessel,Pos[0],Pos[1],Pos[2],Pos[3])
if GlobalMap == 1:    
    PV.GlobalMap()
if LocalMap == 1:    
    PV.LocalMap()
if DraughtInterpolate == 1:
    PV.DraughtInterpolate()    
if TradeDirectionsSuez == 1:
    PV.TradeDirectionSuez()
if TradeDirectionPacific == 1:
    PV.TradeDirectionPacific()
if MonthlyAverage == 1:
    PV.MonthlyAverage()
if FreightRateImpact == 1:
    PV.FreightRateImpact()
if GeoDistribution == 1:    
    PV.GeoDistribution()
if SpeedDev == 1:
    PV.SpeedDev()
if SpeedHistogram == 1:
    PV.SpeedHistogram()
if SpeedForAnalysis == 1:
    PV.SpeedForAnalysis()   
if GeoAnalysis == 1:
    minspeed = 12
    PV.GeoAnalysis(Pos[0],Pos[1],Pos[2],Pos[3],minspeed)
if CumulatedSpeed == 1:
    PV.CumulatedSpeed()    
if DraughtAnalysis == 1:
    PV.DraughtAnalysis()

#If 1, estimate Ornstein-Uhlenbeck Parameters
if OrnsteinUhlenbeckGenerator == 1:
    MaxInterval = 12    #hours
    MinPeriod = 7       #days
    PlotSpeed = 1         
    PlotMap = 0         #1 = yes, 0 = no
    OU.OrnsteinUhlenbeckGenerator(PV.AtTime,PV.AtSpeed,PV.AtLat,PV.AtLon,PlotMap,PlotSpeed,MaxInterval,MinPeriod)
if BigShips == 1:
    BS.FetchSpeedStatsBigShips()
elif Panamax == 1:
    P.FetchSpeedStatsPanamax()
#If 1, start monte carlo simulations
if FuelCalc == 1:
    FA.FuelCalc()
if MuSim == 1:
    ShipUtilization = 0.75
    Years = 1
    AverageTradeDuration = 14 #days
    iterations = 5000
    GS.SimulateSailing(ShipUtilization,Years,AverageTradeDuration,iterations)


